#include <cctype>
#include <algorithm>
#include <list>
#include <iostream>
#include "alphabet.h"
#include "printSequence.h"

using namespace std;

void Alphabet::assign(const char *s) {
  list<string> temp;
  while (*s) {
    string str;
    while (*s && (isspace(*s) || *s==',')) ++s;
    while (*s && isalnum(*s)) str.push_back(*s++);
    if (!str.empty()) temp.push_back(str);
  }
  assign(temp.begin(),temp.end());
}

using std::ostream;
using std::istream;

ostream &Alphabet::print(ostream &os) const {
  PrintSequence<Alphabet::const_iterator> ps(">","","");
  return ps(os,begin(),end());
}

istream &Alphabet::scan(istream &is) {
  char s[128];
  is.getline(s,126);
  assign(s);
  return is;
}

int Alphabet::at(const string &vname) const {
  const_iterator p = find(begin(),end(),vname);
  if (p==end()) return -1;
  return int(p-begin());
}
