#if !defined(__BORDERBASIS_H__)
#define __BORDERBASIS_H__

#include <map>
#include <functional>
#include <ostream>
#include "basis.h"
#include "setofterms.h"

class Report;

class BorderBasis: public std::map<Term,Tpolin> {

public:

	typedef value_type Bpolin;

	static const Monom &lm(const Bpolin &bp) {
		Polin::const_iterator m=bp.second.monom(bp.first);
		PRECONDITION(m!=bp.second.end());
		return *m;
	}
	bool isZeroDim() const {
		return ::isZeroDim(*this,__gnu_cxx::select1st<Bpolin>());
	}
	SetOfTerms nset() const {
		return ::nset(*this,__gnu_cxx::select1st<Bpolin>());
	}

	void add(const Term &lt,const Tpolin &tp) {
		PRECONDITION(tp.monom(lt)!=tp.end() && find(lt)==end());
		insert(value_type(lt,tp));
	}

	BorderBasis close(int i,const SetOfTerms &ns, SetOfTerms &is) const;
	BorderBasis close(const SetOfTerms &ns) const;

	void check(const SetOfTerms &ns, const SetOfTerms &bs,Report &r) const;

	void print(std::ostream &os) const;

private:

	bool close(const Term &s,const SetOfTerms &ns, SetOfTerms &is, BorderBasis &bb, Pcounter &bcount) const;
};

typedef BorderBasis::Bpolin Bpolin;


inline std::ostream &operator<<(std::ostream &os, const BorderBasis &bs) {
	bs.print(os);
	return os;
}

#endif //__BORDERBASIS_H__

