#if !defined __CLASSERROR_H__
#define __CLASSERROR_H__

#include <typeinfo>
#include <stdexcept>
#include <string>

template<class C>
class ClassError: public std::runtime_error {
  static const std::string prefix;
public:
  ClassError (const std::string& what_arg): runtime_error(prefix+what_arg) { }
};


template<class C> const std::string ClassError<C>::prefix = std::string( typeid(C).name() )+"_error: ";

#endif //__CLASS_ERROR_H__
