#if !defined(__CONST_REF_OR_VAL_H)
#define __CONST_REF_OR_VAL_H

#include <type_traits>

template <class C, class T>
struct copy_or_ref {
  // const reference in the general case
  typedef const C& type;
};

template <class C>
struct copy_or_ref<C,std::true_type> {
  // a copy in the case of built-in types
  typedef C type;
};

template <class C>
struct const_ref_or_value {
  // type of the function input argument
  typedef typename copy_or_ref<C,typename  std::is_pod<C>::type>::type func_arg;
};

#define FUNC_ARG(T) const_ref_or_value<T>::func_arg

#endif //__CONST_REF_OR_VAL_H
