#if !defined __ETERMORDER_H__
#define __ETERMORDER_H__

#include <iostream>

class Eterm;

struct ExtOrder {
	virtual bool less(const Eterm &et11, const Eterm &et2) const=0;
	bool equal(const Eterm &et1, const Eterm &et2) const;
	virtual void print(std::ostream &os) const=0;

};

struct EtermOrder {

	EtermOrder(const EtermOrder &mo):m_order(mo.m_order) {}
	EtermOrder &operator=(const EtermOrder &mo) {
		m_order=mo.m_order;
		return *this;
	}
	
	static EtermOrder to();	
	static EtermOrder te();	
	static EtermOrder et();

	bool less(const Eterm &et1, const Eterm &et2) const {
		return m_order->less(et1,et2);
	}	
	bool equal(const Eterm &et1, const Eterm &et2) const {
		return m_order->equal(et1,et2);
	}
	void print(std::ostream &os) const {
		m_order->print(os);
	}

	bool operator==(const EtermOrder &eto) const {
		return m_order==eto.m_order;
	}
	bool operator!=(const EtermOrder &eto) const {
		return m_order!=eto.m_order;
	}
private:
	EtermOrder(ExtOrder * const order):m_order(order) {}
	const ExtOrder * m_order;
};

inline std::ostream &operator<<(std::ostream &os, const EtermOrder &mo) {
	mo.print(os);
	return os;
}

#endif //__ETERMORDER_H__
