#include <algorithm>
#include <iterator>
#include <iomanip>
#include <ext/functional>
#include "alt_binary_compose.h"
#include "report.h"

using namespace std;

Report::Report(const char *fname, int pl, int mw):m_data(new Data(fname,pl,mw)) {
  if (rs()) rs().precision(8);
  else
	  cerr<<"Could not open the report file "<<fname<<'\n';
}

bool Stat::Data::add(const string &key,const string &comment) {
	if (m_vals.insert(Vals::value_type(key,0)).second) {
		pair<Descr::iterator,bool> res=m_descr.insert(Descr::value_type(key,comment));
		PRECONDITION(res.second);
		return true;
	}
	return false;
}

void Report::Data::print(std::ostream &os) const {
	os<<"Report(file="<<filename<<", printLevel="<<printLevel<<", matrixWidth="<<matrWidth<<')';
}

int &Stat::Data::operator[](const string &key) {
	Vals::iterator pos=m_vals.find(key);
	PRECONDITION(pos!=m_vals.end());
	return pos->second;
}

void Stat::Data::print(std::ostream &os) const {
	if (!empty()) {
		os<<"Statistics:\n";
		PRECONDITION(!m_descr.empty());
		int width=max_element(m_descr.begin(),m_descr.end(),
									alt_compose2(
												less<string::size_type>(),
												compose1(mem_fun_ref<string::size_type,string>(&string::size),__gnu_cxx::select2nd<Descr::value_type>()),
												compose1(mem_fun_ref<string::size_type,string>(&string::size),__gnu_cxx::select2nd<Descr::value_type>())
									)
							)->second.size();
		Vals::const_iterator first=m_vals.begin();
		Vals::const_iterator  last=m_vals.end();
		for(;first!=last;++first) {
			Descr::const_iterator dpos=m_descr.find(first->first);
			PRECONDITION(dpos!=m_descr.end());
				os<<setw(width)<<dpos->second<<": "<<first->second<<'\n';
		}
	}
}
