#if !defined(__SETOFMONOMS_H__)
#define __SETOFMONOMS_H__

#include <ostream>
#include <set>
#include <functional>
#include "eterm.h"

  struct FastEtermLess: public std::binary_function<Eterm,Eterm,bool> {
	bool operator()(const Eterm &et1, const Eterm &et2) const {
		return et1.edegree()<et2.edegree() || (et1.edegree()==et2.edegree() && std::lexicographical_compare(et1.begin(),et1.end(),et2.begin(),et2.end()));
	}
};

class SetOfEterms: public std::set<Eterm> {

	typedef std::set<Eterm> Inherited;

public:
	SetOfEterms() = default;
	SetOfEterms(const SetOfEterms &st):Inherited(st) {}
	template<class Iter> SetOfEterms(Iter a, Iter b): Inherited(a,b) {}

	bool subset(const SetOfEterms &st) const;
	bool contains(const Eterm &et) const {
		return find(et)!=end();
	}
	SetOfEterms &unite(const SetOfEterms &st);
	void print(std::ostream &os) const;
};

inline std::ostream &operator<<(std::ostream &os, const SetOfEterms &st) {
	st.print(os);
	return os;
}

#endif //__SETOFMONOMS_H__

