#if !defined(__STRINGCAST_H__)
#define __STRINGCAST_H__

#include <functional>
#include <string>
#include <sstream>

template<class T>
inline std::string string_cast(const T &val) {
	std::ostringstream os;
	os<<val;
	return os.str();
}

template<class T>
inline std::string string_cast(const T &val, int prec) {
	std::ostringstream os;
	os.precision(prec);
	os<<val;
	return os.str();
}

template<class T>
struct string_caster: public std::unary_function<T,std::string> {
	std::string operator()(const T &val) const {
		return string_cast(val);
	}
	std::string operator()(const T &val, int prec) const {
		return string_cast(val, prec);
	}
};

#endif //__STRINGCAST_H__
